<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\financial;


use app\adminapi\lists\BaseAdminDataLists;
use app\adminapi\logic\export\ExportLogic;
use app\common\model\financial\FinancialPaymentRecords;
use app\common\lists\ListsSearchInterface;


/**
 * FinancialPaymentRecords列表
 * Class FinancialPaymentRecordsLists
 * @package app\adminapi\lists
 */
class FinancialPaymentRecordsLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/12/02 11:55
     */
    public function setSearch(): array
    {
        return [
            '=' => ['export_conditions', 'batch_number', 'upload_status', 'payment_status'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/12/02 11:55
     */
    public function lists(): array
    {
        $lists = FinancialPaymentRecords::where($this->searchWhere)
            ->field(['id', 'export_conditions', 'batch_number', 'upload_status', 'payment_status'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
        foreach ($lists as &$item) {
            $item['file_url'] = isset($item['export_conditions']['infoExport_id'])?ExportLogic::detail(['id'=>$item['export_conditions']['infoExport_id']])['file_url']:'';
            $item['settlement_type'] = $item['export_conditions']['settlement_type']??0;
            $item['deadline_time'] = date('Y-m-d', $item['export_conditions']['deadline_time']-1);
        }
        return $lists;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/12/02 11:55
     */
    public function count(): int
    {
        return FinancialPaymentRecords::where($this->searchWhere)->count();
    }

}